import type { SidebarsConfig } from "@docusaurus/plugin-content-docs";

/**
 * Creating a sidebar enables you to:
 - create an ordered group of docs
 - render a sidebar for each doc of that group
 - provide next/previous navigation

 The sidebars can be generated from the filesystem, or explicitly defined here.

 Create as many sidebars as you want.
 */
const sidebars: SidebarsConfig = {
  // By default, Docusaurus generates a sidebar from the docs folder structure
  all: [{ type: "autogenerated", dirName: "." }],

  // But you can create a sidebar manually
  dev: [{ type: "autogenerated", dirName: "dev" }],
  ops: [{ type: "autogenerated", dirName: "ops" }],
  note: [{ type: "autogenerated", dirName: "note" }],
};

export default sidebars;
